=== debian/changelog ===
xen-api-libs (0.1+1318589095-1) lucid; urgency=low

  * New autobuild version

 -- Jon Ludlam <jenkins@snoosnoo2.uk.xensource.com>  Mon, 17 Oct 2011 12:30:50 +0100
