=== debian/changelog ===
xen-api-libs (0.1+1319487461-1) unstable; urgency=low

  * New autobuild version

 --  <jenkins@myvm.uk.xensource.com>  Tue, 25 Oct 2011 02:37:54 +0100
