=== debian/control ===
Source: xen-api-libs
Section: unknown
Priority: extra
Maintainer: Jon Ludlam <jonathan.ludlam@eu.citrix.com>
Build-Depends: debhelper (>= 8.0.0), libxen-ocaml-dev, libxen-ocaml-4.1, ocaml-nox, camlp4, camlp4-extra, ocaml-findlib, autotools-dev, dh-autoreconf, libtype-conv-camlp4-dev, libxmlm-ocaml-dev, uuid-dev, libdevmapper-dev, libxen-dev, libvhd-dev
Standards-Version: 3.9.2
Homepage: <insert the upstream URL, if relevant>
#Vcs-Git: git://git.debian.org/collab-maint/xen-api-libs.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/xen-api-libs.git;a=summary

Package: xen-api-libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: <insert up to 60 chars description>
 <insert long description, indented with spaces>

Package: xen-api-libs-doc
Architecture: all
Description: documentation for xen-api-libs
 <insert long description, indented with spaces>

Package: fe
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fork-and-exec daemon for xapi
 This daemon is the fork-and-exec daemon used by xapi. When xapi requires
 another executable to be run, rather than forking and execing itself, it
 uses this single-threaded daemon to do it, passing fds to it as required.
